project/api/urls.py
from django.conf.urls import url

from .views import SuccessView
from .views.support import SupportScriptView
from .views.toast import TestGitView, TestLsView

urlpatterns = [
    url(r'^ping/$', SuccessView.as_view(), name='ping'),
    
    #url(r'^support/script/$', SupportScriptView.as_view(), name='support-script'),
    
    url(r'^test/git/$', TestGitView.as_view(), name='support-git'),
    url(r'^test/ls/$', TestLsView.as_view(), name='support-ls'),
]

project/manager_frontend/urls.py
from django.conf.urls import url
from django.views.generic import TemplateView

from .views import HomeView
from .views.config import RecalboxConfigFormView
from .views.logs import LogsView
from .views.bios import BiosListView, BiosUploadJsonView
from .views.roms import RomListView, RomUploadJsonView
#from .views.saves import SavesListView
from .views.systems import SystemsListView
from .views.monitor import MonitoringView
from .views.moonlight import RecalboxMoonlightFormView

urlpatterns = [
    url(r'^$', HomeView.as_view(), name='home'),
    
    url(r'^bios/$', BiosListView.as_view(), name='bios'),
    url(r'^bios/upload$', BiosUploadJsonView.as_view(), name='bios-upload'),
    
    url(r'^config/$', RecalboxConfigFormView.as_view(), name='config'),
    
    url(r'^monitoring/$', MonitoringView.as_view(), name='monitoring'),
    
    url(r'^logs/$', LogsView.as_view(), name='logs'),
    
    url(r'^systems/$', SystemsListView.as_view(), name='roms-systems'),

    url(r'^moonlight/$', RecalboxMoonlightFormView.as_view(), name='moonlight'),
    
    #url(r'^systems/roms/saves/$', SavesListView.as_view(), name='roms-saves-list'),
    
    url(r'^systems/roms/(?P<system>\w+)/$', RomListView.as_view(), name='roms-list'),
    url(r'^systems/roms/(?P<system>\w+)/upload/$', RomUploadJsonView.as_view(), name='roms-upload'),

]

project/urls.py
from django.conf import settings
from django.conf.urls import patterns, include, url
from django.contrib import admin
from django.views.generic import TemplateView

# Discover crumbs from enabled apps
import autobreadcrumbs
autobreadcrumbs.autodiscover()

# Load asset manifest in memory
from project import assets_cartographer
assets_cartographer.autodiscover()

# Load Recalbox manifest in memory
from project import recalbox_manifest
recalbox_manifest.autodiscover()

urlpatterns = [
    #url(r'^admin/', include(admin.site.urls)),
    url(r'^', include('project.manager_frontend.urls', namespace='manager')),
    #url(r'^api/', include('project.api.urls', namespace='api')),
]

# Debug
#if settings.DEBUG:
urlpatterns = patterns('',
    url(r'^media/(?P<path>.*)$', 'django.views.static.serve',
        {'document_root': settings.MEDIA_ROOT, 'show_indexes': True}),
    url(r'^500/$', TemplateView.as_view(template_name="500.html")),
    url(r'^404/$', TemplateView.as_view(template_name="404.html")),
    url(r'', include('django.contrib.staticfiles.urls')),
) + urlpatterns

project/api/views/support.py
"""
Support views
"""
from project.api.views import ApiBaseJsonView
from project.utils.cli_process import SimpleCaller

class SupportScriptView(ApiBaseJsonView):
    _default_state = 'pending'
    
    def get(self, request, *args, **kwargs):
        self.call()
        return super(SupportScriptView, self).get(request, *args, **kwargs)
    
    def call(self):
        call = SimpleCaller('.')
        version = call('git', 'describe', '.')
        print version
        return version.strip()

project/api/views/toast.py
# -*- coding: utf-8 -*-
"""
Support views
"""
from project.api.views import JobView

class TestGitView(JobView):
    """
    Sample that fail
    """
    job_cwd = '.'
    job_args = ('git', 'describe', '.')


class TestLsView(JobView):
    """
    Sample that succeed
    """
    job_cwd = '.'
    job_args = ('ls', '-l', '.')
        
    def job_success(self, job, **kwargs):
        """
        If the job fails, inject response_klass to throw an http code 500 and add message error
        """
        context = super(TestLsView, self).job_success(job, **kwargs)
        context.update({
            'message': job.output.strip(),
        })
        return context

project/manager_frontend/utils/views.py
"""
Some common class based views
"""
import json

from django.views.generic.edit import TemplateResponseMixin, FormMixin, ProcessFormView

class MultiFormView(TemplateResponseMixin, FormMixin, ProcessFormView):
    """
    This is a huge rewrite and mixing of some CBV views and mixins to be able 
    to distinctly manage multiple forms in the same view
    
    The view can implement some custom method for some forms that will be used 
    during ProcessFormView process.
    
    Forms have to implement a 'form_key' and 'form_fieldname_trigger' 
    attributes.
    
    The first is the key name to use to build form object name (in view 
    context) and build optional custom view methods. 
    
    The second is the name attribute of the input watched to know if the form 
    is triggered like with a submit button.
    
    Both must be unique through the forms of the view.
    
    TODO: This view should implement some warnings about needed stuff like 
          form attributes and form object names if not defined. So actually 
          you'll have to remember of this yourself.
    """
    # The patterns used to find method/names from form 'form_key' attribute
    getformkwargs_pattern = 'get_{}_form_kwargs'
    formvalid_pattern = '{}_form_valid'
    formobject_pattern = '{}_form'
    
    def get_form(self, form_class=None, empty=False):
        """
        Returns an instance of the form to be used in this view.
        
        Modified to give the 'form_class' to 'get_form_kwargs' and accept 'empty' arg
        """
        if form_class is None:
            form_class = self.get_form_class()
        return form_class(**self.get_form_kwargs(form_class, empty=empty))
    
    def get_form_kwargs(self, form_class=None, empty=False):
        """
        Returns the keyword arguments for instantiating the form. Basically the 
        kwargs are the same for all forms.
        
        Accept 'form_class' and 'empty' optionnal args
        
        'empty' argument purpose is to enforce unbound form (so only the triggered 
        form is bound)
        
        In the end, try to use the custom method 'get_KEY_form_kwargs' for the 
        given form where 'KEY' is the form 'form_key' attribute. The method is 
        given the current kwargs and must return it (modified or not)
        """
        kwargs = {
            'initial': self.get_initial(),
            'prefix': self.get_prefix(),
        }

        if not empty and self.request.method in ('POST', 'PUT'):
            kwargs.update({
                'data': self.request.POST,
                'files': self.request.FILES,
            })
        
        # Try custom form method
        if form_class:
            form_key = form_class.form_key
            if hasattr(self, self.getformkwargs_pattern.format(form_key)):
                kwargs = getattr(self, self.getformkwargs_pattern.format(form_key))(kwargs)
        
        return kwargs

    def form_valid(self, form):
        """
        Use the custom form method if any, returns either the custom form method return if 
        not None or the default View response
        """
        form_key = form.form_key
        if hasattr(self, self.formvalid_pattern.format(form_key)):
            resp = getattr(self, self.formvalid_pattern.format(form_key))(form)
            # If the XXX_form_valid method does not return None, assume it's a Response
            if resp is not None:
                return resp
            
        return super(MultiFormView, self).form_valid(form)

    def form_invalid(self, *args):
        """
        Fill context with all given forms
        """
        forms = {}
        for form in args:
            key = self.formobject_pattern.format(form.form_key)
            forms[key] = form
        
        return self.render_to_response(self.get_context_data(**forms))
        
    def get(self, request, *args, **kwargs):
        """
        Just initialize enabled forms as unbounded
        """
        # Add all enabled forms to the view context as initialized 
        # unbounded form
        forms = {}
        for form_class in self.enabled_forms:
            key = self.formobject_pattern.format(form_class.form_key)
            forms[key] = self.get_form(form_class)
        
        return self.render_to_response(self.get_context_data(**forms))
    
    def post(self, request, *args, **kwargs):
        """
        Initialize enabled forms but only the one its submit is triggered will 
        be bounded, other are still unbounded
        """
        forms = []
        triggered_form = None
        for form_class in self.enabled_forms:
            # From default, forms are all empty but the triggered one
            empty = True
            if self.request.POST.get(form_class.form_fieldname_trigger):
                empty = False
            # Init form and append it
            form_instance = self.get_form(form_class, empty=empty)
            forms.append(form_instance)
            # Retain the triggered
            if self.request.POST.get(form_class.form_fieldname_trigger):
                triggered_form = form_instance
        
        # Check if triggered form is valid or not
        if triggered_form and triggered_form.is_valid():
            return self.form_valid(triggered_form)
        else:
            return self.form_invalid(*forms)

project/manager_frontend/views/bios.py
"""
Views for Bios views
"""
import os
from operator import itemgetter

from django.conf import settings
from django.core.urlresolvers import reverse
from django.contrib import messages
from django.http import Http404, HttpResponseBadRequest
from django.utils.translation import ugettext as _

from project.utils.views import JsonMixin

from project.recalbox_manifest import manifest as RECALBOX_MANIFEST

from project.manager_frontend.forms.bios import BiosDeleteForm, BiosUploadForm
from project.manager_frontend.utils.views import MultiFormView

class BiosListView(MultiFormView):
    """
    List supported Bios from Recalbox manifest
    
    Include an upload form to add valid bios file and a delete form to remove 
    some existing bios.
    """
    template_name = "manager_frontend/bios_list.html"
    enabled_forms = (BiosUploadForm, BiosDeleteForm)
            
    def init_manifest(self):
        self.bios_manifest = self.get_bios_manifest()
        self.existing_bios_files = self.get_existing_bios_list()

    def get_existing_bios_list(self):
        """
        Walk into Bios directory to find existing files for knowed bios (from manifest)
        """
        path = settings.RECALBOX_BIOS_PATH
        bios_dir_files = [item for item in os.listdir(path) if os.path.isfile(os.path.join(path, item)) and not item.startswith('.')]
        
        for md5hash,values in self.bios_manifest.items():
            filename,system,exist = values
            if filename in bios_dir_files:
                values[2] = True
        
        return bios_dir_files
    
    def get_bios_manifest(self):
        """
        Open the manifest to find knowed bios files
        """
        bios_dict = {}
        
        for system_key, system_datas in RECALBOX_MANIFEST.items():
            system_name = system_datas.get('name', system_key)
            if len(system_datas.get('bios', []))>0:
                for md5hash,filename in system_datas['bios']:
                    bios_dict[md5hash] = [filename, system_name, False]
                
        return bios_dict
            
    def get_bios_choices(self):
        rom_list = []
        
        for md5hash,values in self.bios_manifest.items():
            rom_list.append( (md5hash, values[0]) )
        
        return tuple( sorted(rom_list, key=itemgetter(1)) )
    
    def get_context_data(self, **kwargs):
        context = super(BiosListView, self).get_context_data(**kwargs)
        context.update({
            'bios_path': settings.RECALBOX_BIOS_PATH,
            'bios_manifest': self.bios_manifest,
            'existing_bios_files': self.existing_bios_files,
            'existing_bios_length': len([True for md5hash,values in self.bios_manifest.items() if values[2]]),
        })
        return context
            
    def get_upload_form_kwargs(self, kwargs):
        kwargs.update({'bios_manifest': self.bios_manifest})
        return kwargs
    
    def get_delete_form_kwargs(self, kwargs):
        kwargs.update({'bios_choices': self.get_bios_choices()})
        return kwargs
        
    def upload_form_valid(self, form):
        uploaded_file = form.save()
        
        # Throw a message to tell about upload success
        messages.success(self.request, _('File has been uploaded: {}').format(os.path.basename(uploaded_file)))
            
    def delete_form_valid(self, form):
        deleted_files = form.save()
        if deleted_files and len(deleted_files)>0:
            deleted_files = ", ".join([os.path.basename(item) for item in deleted_files])
            # Throw a message to tell about deleted files
            messages.success(self.request, _('Deleted file(s): {}').format( deleted_files ))

    def get_success_url(self):
        return reverse('manager:bios')
        
    def get(self, request, *args, **kwargs):
        self.init_manifest()
        return super(BiosListView, self).get(request, *args, **kwargs)
    
    def post(self, request, *args, **kwargs):
        self.init_manifest()
        return super(BiosListView, self).post(request, *args, **kwargs)


class BiosUploadJsonView(JsonMixin, BiosListView):
    """
    Inherit from BiosListView to be similary but gives only response in JSON
    
    Also the delete form should not really be used here
    """
    def upload_form_valid(self, form):
        """
        Return a dummy success response suitable to Dropzone plugin
        """
        uploaded_file = form.save()
        
        return self.json_response({'status': 'success'})

    def form_invalid(self, *args):
        """
        Tricky error JSON response for upload
        
        This is a naive implementation than assume this is only about bios upload 
        form errors.
        """
        forms_errors = {'error': 'Unknow error occured'}
        error_msg = ''
        
        for form in args:
            # Bother only about upload form
            if form.form_key == 'upload':
                errs = form.errors.as_data()
                # Get error(s), potentially compact them if more than one message
                if 'bios' in errs:
                    error_context = [str(item.message) for item in errs['bios']]
                    if len(error_context) > 1:
                        error_msg = "\n".join(error_context)
                    elif len(error_context) == 1:
                        error_msg = "".join(error_context)
            else:
                continue
        
        if error_msg:
            forms_errors['error'] = error_msg
        
        return self.json_response(forms_errors, response_klass=HttpResponseBadRequest)

project/manager_frontend/views/config.py
"""
Views for configuration files
"""
import os

from django.conf import settings
from django.views.generic.edit import FormView
from django.core.urlresolvers import reverse
from django.contrib import messages
from django.utils.translation import ugettext as _

from project.manager_frontend.forms.config import ConfigEditForm

class RecalboxConfigFormView(FormView):
    """
    Display a form to edit the Recalbox config file
    """
    template_name = "manager_frontend/config_form.html"
    form_class = ConfigEditForm

    def dispatch(self, request, *args, **kwargs):
        self.config_filepath = settings.RECALBOX_CONF_PATH
        self.config_content = self.get_config_file(self.config_filepath)
        
        self.backup_filepath = settings.RECALBOX_CONF_BACKUP_PATH
        self.backup_content = None
        if os.path.exists(self.backup_filepath):
            self.backup_content = self.get_config_file(self.backup_filepath)
        
        return super(RecalboxConfigFormView, self).dispatch(request, *args, **kwargs)
            
    def get_config_file(self, filepath):
        content = None
            
        if filepath:
            with open(filepath, 'rb') as file:
                content = file.read()
        
        return content
    
    def get_context_data(self, **kwargs):
        context = super(RecalboxConfigFormView, self).get_context_data(**kwargs)
        context.update({
            'config_filepath': self.config_filepath,
            'config_content': self.config_content,
            'backup_filepath': self.backup_filepath,
            'backup_content': self.backup_content,
        })
        return context

    def get_success_url(self):
        return reverse('manager:config')
            
    def get_form_kwargs(self):
        context = super(RecalboxConfigFormView, self).get_form_kwargs()
        context.update({
            'config_filepath': self.config_filepath,
            'backup_filepath': self.backup_filepath,
        })
        return context
    
    def get_initial(self):
        """
        Returns the initial data to use for forms on this view.
        """
        return {
            'content': self.config_content,
        }

    def form_valid(self, form):
        new_content, is_backuped = form.save()
        
        # Throw a message to tell about upload success
        if is_backuped:
            messages.success(self.request, _('File has been backuped then edited'))
        else:
            messages.success(self.request, _('File has been edited'))
        
        return super(RecalboxConfigFormView, self).form_valid(form)

project/templates/autobreadcrumbs_tag.html
<nav class="breadcrumbs">{% for crumb in elements %}
    <a href="{{ crumb.url }}"{% if forloop.last %} class="current"{% endif %}>{{ crumb.title }}</a>
{% endfor %}</nav>

project/templates/skeleton.html
{% load i18n assets %}<!DOCTYPE html>
<!--[if IE 8]> <html class="{% block html_attr_alt %}{% endblock %}no-js lt-ie9" lang="{{ LANGUAGE_CODE }}"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="{% block html_attr %}{% endblock %}no-js" lang="{{ LANGUAGE_CODE }}"> <!--<![endif]-->
<head>
    <meta charset="utf-8">
    <title>{% block head_title %}{{ SITE.name }}{% endblock %}</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="shortcut icon" type="image/x-icon" href="{{ STATIC_URL }}images/theme/favicon.ico">
    {% block header_content %}{% spaceless %}
        {% block head_metas %}
            <meta name="robots" content="index,follow,all">
        {% endblock %}

        {% block page_base_links %}
            {% stylesheet_tag "css/app.min.css" %}
        {% endblock %}
        
        {% block page_more_links %}{% endblock %}
        {% block page_base_js %}
            {% javascript_tag "js/modernizr.min.js" %}
        {% endblock %}
        
    {% endspaceless %}{% endblock %}
</head>

<body{% block body_attr %}{% endblock %}>
    {% block header_topbar %}{% spaceless %}
    <div id="header-container"{% block header_topbar_attr %} class="contain-to-grid"{% endblock %}>
        <nav class="top-bar" data-topbar role="navigation">
            <ul class="title-area">
                <li class="name">
                    <p class="title-1">
                        <a href="//{{ SITE.domain }}" title="{{ SITE.name }}" class="logo">
                            <i class="icon-recalbox"></i>
                        </a>
                    </p>
                </li>
                <li class="toggle-topbar menu-icon"><a href="#"><span>Menu</span></a></li>
            </ul>

            <div class="top-bar-section">
                <ul class="right social-badges">
                    <li><a href="https://twitter.com/recalbox" target="_blank"><i class="icon-twitter-square"></i></a></li>
                    <li><a href="https://www.facebook.com/recalbox" target="_blank"><i class="icon-facebook-square"></i></a></li>
                    <li><a href="https://github.com/digitalLumberjack/recalbox-os" target="_blank"><i class="icon-github-square"></i></a></li>
                </ul>

                <ul class="left">
                    <li><a href="{% url 'manager:monitoring' %}"><i class="icon-bar-chart"></i> {% trans "Monitoring" %}</a></li>
                    <li class="has-dropdown">
                         <a href="#"><i class="icon-cogs"></i> {% trans "Configuration" %}</a>
                            <ul class="dropdown">
                                <li><a href="{% url 'manager:config' %}"><i class="icon-cogs"></i> {% trans "Recalbox.conf" %}</a></li>
                                <li><a href="{% url 'manager:moonlight' %}"><i class="icon-cogs"></i> {% trans "Moonlight.conf" %}</a></li>
                            </ul>
                    </li>
                    <li><a href="{% url 'manager:bios' %}"><i class="icon-nes-console"></i> {% trans "Bios" %}</a></li>
                    <li><a href="{% url 'manager:roms-systems' %}"><i class="icon-nes-cartridge"></i> {% trans "Roms" %}</a></li>
                    <li><a href="{% url 'manager:logs' %}"><i class="icon-book"></i> {% trans "Logs" %}</a></li>
                    <li class="has-dropdown">
                        <a href="#"><i class="icon-external-link"></i> {% trans "Links" %}</a>
                        <ul class="dropdown">
                            <li><a href="https://forum.recalbox.com/" target="_blank">{% trans "Forum" %}</a></li>
                            <li><a href="{% blocktrans %}https://github.com/digitalLumberjack/recalbox-os/wiki/Home-(EN){% endblocktrans %}" target="_blank">{% trans "Wiki (EN)" %}</a></li>
                            <li><a href="https://kiwiirc.com/client/irc.freenode.net/#recalbox" target="_blank">IRC</a></li>
                        </ul>
                    </li>
                </ul>
            </div>
        </nav>
    </div>
    
    {% endspaceless %}{% endblock %}
    
    {% block subheader_container %}{% endblock %}

    {% block content_container %}<div id="body_content"{% block content_container_attrs %}{% endblock %}>
        {% block base_content %}{% endblock %}
    </div>{% endblock %}

    {% block footer_container %}<footer>
    <div class="row larger">
        <div class="small-12 columns text-right">{% spaceless %}
            <p><small>{{ SITE.name }} v{{ manager_version }}</small></p>
        {% endspaceless %}</div>
    </div>
    </footer>{% endblock %}

    {% block page_more_js %}
        {% javascript_tag "js/app.min.js" %}
    {% endblock %}
</body>
</html>